#include <iostream>

using namespace std;

int main()
{
    int n,m;
  cin>>n>>m;
  char mapa[n][m];
  bool vatra[n][m];
  bool stevo [n][m];
  int br=0;
bool vatraPostoji=false;
 int Stevo=0;

  for(int i=0;i<n;i++){
 for(int j=0;j<m;j++){
    cin>>mapa[i][j];
    vatra[i][j]=false;
    stevo [i][j]=false;
    if(mapa[i][j]=='.'){
        br++;
    }
    else if(mapa[i][j]=='X'){
        vatra[i][j]=true;
        bool vatraPostoji=true;
    }
    else if(mapa[i][j]=='S'){
        stevo[i][j]=true;
    }
 }
  }


  //Igra
  while(br>0){
        //Vatra
        if(vatraPostoji){
   for(int i=0;i<n;i++){
 for(int j=0;j<m;j++){
    if(vatra[i][j]){

        if(i-1>=0){
        if(mapa[i-1][j]=='.'){
            mapa[i-1][j]='X';
            br--;

        }
        }
        if(i+1<n){
            if(mapa[i+1][j]=='.'){
               mapa[i+1][j]='X';
               br--;

            }
        }
         if(j-1>=0){
        if(mapa[i][j-1]=='.'){
            mapa[i][j-1]='X';
            br--;

        }

        }
        if(j+1<m){
            if(mapa[i][j+1]=='.'){
               mapa[i][j+1]='X';
               br--;

            }
        }
    }
 }
  }
        }

  //Stevo
  for(int i=0;i<n;i++){
 for(int j=0;j<m;j++){
    if(stevo[i][j]){

        if(i-1>=0){
        if(mapa[i-1][j]=='.'){
            mapa[i-1][j]='S';
            br--;
            Stevo++;

            }
        }
        if(i+1<n){
            if(mapa[i+1][j]=='.'){
               mapa[i+1][j]='S';
               br--;
               Stevo++;
            }
        }
         if(j-1>=0){
        if(mapa[i][j-1]=='.'){
            mapa[i][j-1]='S';
            br--;
            Stevo++;
        }
        }
        if(j+1<m){
            if(mapa[i][j+1]=='.'){
               mapa[i][j+1]='S';
               br--;
               Stevo++;
            }
        }
    }
 }
  }
  //Nova mapa
  for(int i=0;i<n;i++){
 for(int j=0;j<m;j++){
   if(mapa[i][j]=='X'){
    vatra[i][j]=true;
   }
else if(mapa[i][j]=='S'){
    stevo[i][j]=true;
}
 }
  }



  }
  Stevo++;
  cout<<Stevo<<endl;
    return 0;
}